<?php

/**
 * @file
 * Integration with the Feeds module.
 */


/**
 * Implements hook_feeds_processor_targets_alter().
 */
function rut_field_feeds_processor_targets_alter(&$targets, $type, $bundle) {
  foreach (field_info_instances($type, $bundle) as $name => $instance) {
    $info = field_info_field($name);
    if ($info['type'] == 'rut_field') {
      $targets[$name] = array(
        'name' => $instance['label'],
        'callback' => 'rut_field_feeds_set_target',
        'description' => t('The @name field of the entity.', array('@name' => $instance['label'])),
      );
    }
  }
}


/**
 * Callback for hook_feeds_processor_targets_alter().
 *
 * @param $source
 *   Field mapper source settings.
 * @param $entity
 *   An entity object.
 * @param $target
 *   A string identifying the target on the entity.
 * @param $values
 *   The value to populate the target with.
 */
function rut_field_feeds_set_target($source, $entity, $target, array $values) {
  $field = isset($entity->$target) ? $entity->$target : array(LANGUAGE_NONE => array());

  foreach ($values as $value) {
    list($rut, $dv) = rut_separate_rut($value);
    if ($value && rut_validate_rut($rut, $dv)) {
      $field[LANGUAGE_NONE][] = array('value' => $value);
    }
  }

  $entity->$target = $field;
}
